#include mdv1_stdio_h

char *base,*mat;
int pond;
int nx,ny,xl,noc;
char fnn[60];

main()
{
int g;
g=init();
if(g==0)
   {
   draw();
   fint();
   }
}

init()
{
int x,y,z,fin;
z=1; mode(4); paper(1,0); window(1,512,256,0,0); cls(1);
base=mlalloc(32000L); mat=mlalloc(40000L);
if(mat!=NULL&&base!=NULL)
   {
   printf("input filename ? ");
   fgets(fnn,60,stdin); fnn[strlen(fnn)-1]='\0';
   fin=fopen(fnn,"rb");
   if(fin!=NULL)
      {
      xl=0;
      while((base[xl++]=fgetc(fin))!=EOF);
      noc=base[0]*256+base[1]; nx=(base[2]*2+4)*3; ny=(base[3]*2+4)*2;
      printf("\n\nnumber of characters = %d\n\n",noc);
      fclose(fin);
      z=0;
      }
   }
return z;
}

draw()
{
int n,x,y,z,cx,cy,ocx,ocy,ecx,ecy,g;
int a,b,xy,noe,nof,v;
long c,g;
for(n=32;n<32+noc;n++)
   {
   for(x=0;x<nx;x++)
      for(y=0;y<ny;y++)
         mat[x+y*nx]=0;
   pond=base[n*2+4]*256+base[n*2+5];
   if(pond)
      {
      noe=base[pond+2]; nof=base[pond+3]; pond+=4;
      cls(1); printf("no. of fills = %d",nof);
      for(v=0;v<noe;v++)
         {
         ocx=base[pond]; ocy=base[pond+1];
         ecx=base[pond+2]; ecy=base[pond+3];
         g=base[pond+4]*256+base[pond+5];
         g*=100; pond+=6;
         xy=0; if(ocx&128) { ocx=256-ocx; xy=1; }
         a=ecy-ocy; b=ecx-ocx;
         if(xy)
            { z=a; a=b; b=z; }
         c=(a*10000L-g*b)/b/b;
         glup(xy,ocx,ocy,ecx,ecy,g,c);
         }
      for(v=0;v<nof;v++)
         {
         cx=base[pond+v*2]*3+1; cy=base[pond+v*2+1]*2-1;
         if(mat[cx+cy*nx]||(cx==1&&cy==-1)) fail(v,pond);
         else if(flood(cx,cy)) { fail(v,pond); n--; break; }
         }
      }
   if(keyrow(1)) break;
   }
}

glup(xy,ocx,ocy,ecx,ecy,g,c)
int xy,ocx,ocy,ecx,ecy;
long g,c;
{
int x,y,z,x1,y1,oy,ox,ay,ax,sy1,sy2,sx1,sx2;
if(xy)
   {
   z=abs(ecy-ocy)*2;
   ox=3*ocx;
   for(y=0;y<=z;y++)
      {
      y1=y; if(ecy-ocy<0) y1=-y;
      x=3*ocx+(3*g*y1/2+3*c*y1*y1/4)/10000;
      sx1=ox; sx2=x; if(ox>x) { sx1=x; sx2=ox; }
      for(ax=sx1;ax<=sx2;ax++) spot(ax,y1+ocy*2,7);
      ox=x;
      }
   }
else
   {
   z=abs(ecx-ocx)*3;
   oy=2*ocy;
   for(x=0;x<=z;x++)
      {
      x1=x; if(ecx-ocx<0) x1=-x;
      y=2*ocy+(g*x1/3+c*x1*x1/9)/5000;
      sy1=oy; sy2=y; if(oy>y) { sy1=y; sy2=oy; }
      for(ay=sy1;ay<=sy2;ay++) spot(x1+ocx*3,ay,7);
      oy=y;
      }
   }
}

spot(x,y,z)
int x,y,z;
{
block(1,1,1,x+256,y+12,z);
mat[x+y*nx]=z;
}

fint()
{
int fout,x;
fout=fopen(fnn,"wb");
x=0;
do fputc(base[x++],fout); while(x<xl-1);
fclose(fout);
}

fail(v,pond)
int v,pond;
{
base[pond+v*2]=0; base[pond+v*2+1]=0;
}

int nvec,vec[200];

push(a,b)
int a,b;
{
vec[nvec*2]=a; vec[nvec*2+1]=b; nvec++;
}

pull(a,b)
int *a,*b;
{
if(nvec)
   { nvec--; *a=vec[nvec*2]; *b=vec[nvec*2+1]; return 1; }
else
   return 0;
}

flood(cx,cy)
int cx,cy;
{
nvec=0; push(cx,cy); return flod();
}

flod()
{
int ugot,dgot,vx,vy,ovx,slog;
slog=0;
do {
   ugot=0; dgot=0; if(!pull(&vx,&vy)) break;
   ovx=vx;
   do {
      if((!ugot)&&(!mat[vx+(vy+1)*nx])) { ugot=1; push(vx,vy+1); }
      if(ugot&&mat[vx+(vy+1)*nx]) ugot=0;
      if((!dgot)&&(!mat[vx+(vy-1)*nx])) { dgot=1; push(vx,vy-1); }
      if(dgot&&mat[vx+(vy-1)*nx]) dgot=0;
      spot(vx,vy,7); vx++; if(vx>=nx) { slog=1; break; }
      if(mat[vx+vy*nx]) break;
      } while(1);
   if(slog) break;
   ugot=0; dgot=0; vx=ovx-1;
   do {
      if(mat[vx+vy*nx]) break;
      if((!ugot)&&(!mat[vx+(vy+1)*nx])) { ugot=1; push(vx,vy+1); }
      if(ugot&&mat[vx+(vy+1)*nx]) ugot=0;
      if((!dgot)&&(!mat[vx+(vy-1)*nx])) { dgot=1; push(vx,vy-1); }
      if(dgot&&mat[vx+(vy-1)*nx]) dgot=0;
      spot(vx,vy,7); vx--; if(vx<0) { slog=1; break; }
      } while(1);
   if(slog) break;
   } while(1);
if(slog) return 1;
else return 0;
}


